// 当前等待的渲染列表
import 'builder.dart';
import 'compute.dart';
import 'ref.dart';
import 'helpers/tools.dart';
import 'watch.dart';

List _renderWidgetList = [];
bool _shouldActiveRender = true;

_render(Ref refInstance) {
  List<StreamCollectFactory> _tempRefs = [];
  _renderWidgetList.forEach((ele) {
    // 去重
    if (!_tempRefs.contains(ele)) {
      _tempRefs.add(ele);
      try {
        (ele as StreamCollectFactory).instance.add(refInstance);
      } catch (e) {
        print('app wrong: Ref effect 调用instance.sink.add(refInstance)出错了！');
      }
    }
  });
  _renderWidgetList.clear();
  _shouldActiveRender = true;
}

// 执行页面渲染
renderWidget(dynamic instance, Ref refInstance) {
  if (instance is List) {
    _renderWidgetList.addAll(instance);
  } else {
    _renderWidgetList.add(instance);
  }
  if (_shouldActiveRender) {
    _shouldActiveRender = false;
    Future.delayed(Duration(milliseconds: 1), () {
      _render(refInstance);
    });
  }
}

// 执行副作用
excuteEffect<T>(List<T> effectList) {
  listUnRepeat(effectList).forEach((ele) {
    if (ele is WatchCollectFactory) {
      ele.instance.excute();
    } else if (ele is ComputeComputeFactory) {
      ele.instance.excute();
    }
  });
}
